/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 *
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 *
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * ====================================================================
 *
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
package vocal.ui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import vocal.data.GlobalData;
import vocal.data.InvalidRequestException;
import vocal.data.TreeNodeTypes;
import vocal.data.ConfigTree;
import javax.swing.border.Border;

/*
 * SystemData.java
 *
 * Created on July 11, 2002, 9:46 AM
 * Using Forte for Java 4, Community Edition
 */


public class SystemData extends FormPanelScreen
{
  
  private ConfigTree configTree1;
  private ConfigureServers mainScreen;
  private GlobalData dataManager;
  
  /** Creates new form SystemData */
  public SystemData(ConfigureServers screen)
  {
    mainScreen = screen;
    configTree1 = mainScreen.getConfigTree();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    mainPanel = new javax.swing.JPanel();
    jScrollPane1 = new javax.swing.JScrollPane();
    scrollablePanel = new javax.swing.JPanel();
    northPanel = new javax.swing.JPanel();
    titleLabel = new javax.swing.JLabel();
    centerPanelVert = new javax.swing.JPanel();
    centerPanelHoriz = new javax.swing.JPanel();
    labelPanel = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    expiryTimerLabel = new javax.swing.JLabel();
    jPanel31 = new javax.swing.JPanel();
    multicastHostLabel = new javax.swing.JLabel();
    jPanel32 = new javax.swing.JPanel();
    multicastPortLabel = new javax.swing.JLabel();
    jPanel33 = new javax.swing.JPanel();
    heartBeatIntLabel = new javax.swing.JLabel();
    jPanel34 = new javax.swing.JPanel();
    maxMissedHBLabel = new javax.swing.JLabel();
    jPanel35 = new javax.swing.JPanel();
    proxyAuthKeyLabel = new javax.swing.JLabel();
    jPanel36 = new javax.swing.JPanel();
    redirectReasonLabel = new javax.swing.JLabel();
    fieldPanel = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    expTimerField = new vocal.ui.WholeNumberField();
    jPanel11 = new javax.swing.JPanel();
    multiHostField = new vocal.ui.HostNameField();
    jPanel12 = new javax.swing.JPanel();
    portField = new vocal.ui.WholeNumberField();
    jPanel13 = new javax.swing.JPanel();
    hbIntervalField = new vocal.ui.WholeNumberField();
    jPanel14 = new javax.swing.JPanel();
    missedHbField = new vocal.ui.WholeNumberField();
    jPanel15 = new javax.swing.JPanel();
    proxyAuthKeyTextField = new vocal.ui.InternalClipboardField();
    jPanel16 = new javax.swing.JPanel();
    redirectReasonCheckBox = new javax.swing.JCheckBox();
    autoProvPanel = new javax.swing.JPanel();
    apLabelPanel = new javax.swing.JPanel();
    jPanel37 = new javax.swing.JPanel();
    lowestUIDLabel = new javax.swing.JLabel();
    jPanel38 = new javax.swing.JPanel();
    highestUIDLabel = new javax.swing.JLabel();
    apFieldPanel = new javax.swing.JPanel();
    jPanel17 = new javax.swing.JPanel();
    lowestUIDField = new vocal.ui.UserNameField();
    jPanel18 = new javax.swing.JPanel();
    highestUIDField = new vocal.ui.UserNameField();

    setLayout(new java.awt.BorderLayout());

    mainPanel.setLayout(new java.awt.BorderLayout());

    scrollablePanel.setLayout(new java.awt.BorderLayout());

    northPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(20, 0, 20, 0)));
    titleLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    titleLabel.setText("System Configuration Data");
    northPanel.add(titleLabel);

    scrollablePanel.add(northPanel, java.awt.BorderLayout.NORTH);

    centerPanelVert.setLayout(new javax.swing.BoxLayout(centerPanelVert, javax.swing.BoxLayout.Y_AXIS));

    centerPanelHoriz.setLayout(new javax.swing.BoxLayout(centerPanelHoriz, javax.swing.BoxLayout.X_AXIS));

    labelPanel.setLayout(new javax.swing.BoxLayout(labelPanel, javax.swing.BoxLayout.Y_AXIS));

    jPanel3.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    expiryTimerLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    expiryTimerLabel.setText("Expiry Timer (s):");
    expiryTimerLabel.setAlignmentX(1.0F);
    expiryTimerLabel.setAlignmentY(0.0F);
    jPanel3.add(expiryTimerLabel);

    labelPanel.add(jPanel3);

    jPanel31.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel31.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    multicastHostLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    multicastHostLabel.setText("Multicast Host:");
    multicastHostLabel.setAlignmentX(1.0F);
    multicastHostLabel.setAlignmentY(0.0F);
    jPanel31.add(multicastHostLabel);

    labelPanel.add(jPanel31);

    jPanel32.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel32.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    multicastPortLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    multicastPortLabel.setText("Multicast Port:");
    multicastPortLabel.setAlignmentX(1.0F);
    multicastPortLabel.setAlignmentY(0.0F);
    jPanel32.add(multicastPortLabel);

    labelPanel.add(jPanel32);

    jPanel33.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel33.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    heartBeatIntLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    heartBeatIntLabel.setText("HeartBeat Interval (ms):");
    heartBeatIntLabel.setAlignmentX(1.0F);
    heartBeatIntLabel.setAlignmentY(0.0F);
    jPanel33.add(heartBeatIntLabel);

    labelPanel.add(jPanel33);

    jPanel34.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel34.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    maxMissedHBLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    maxMissedHBLabel.setText("Max. Missed HeartBeats:");
    maxMissedHBLabel.setAlignmentX(1.0F);
    maxMissedHBLabel.setAlignmentY(0.0F);
    jPanel34.add(maxMissedHBLabel);

    labelPanel.add(jPanel34);

    jPanel35.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel35.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    proxyAuthKeyLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    proxyAuthKeyLabel.setText("Proxy Authorization Key:");
    proxyAuthKeyLabel.setAlignmentX(1.0F);
    proxyAuthKeyLabel.setAlignmentY(0.0F);
    jPanel35.add(proxyAuthKeyLabel);

    labelPanel.add(jPanel35);

    jPanel36.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel36.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    redirectReasonLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    redirectReasonLabel.setText("Redirect Reason in SIP:");
    redirectReasonLabel.setAlignmentX(1.0F);
    redirectReasonLabel.setAlignmentY(0.0F);
    jPanel36.add(redirectReasonLabel);

    labelPanel.add(jPanel36);

    centerPanelHoriz.add(labelPanel);

    fieldPanel.setLayout(new javax.swing.BoxLayout(fieldPanel, javax.swing.BoxLayout.Y_AXIS));

    jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    expTimerField.setToolTipText("maximum time user can remain registered with the system until another SIP Register message must be sent");
    expTimerField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel1.add(expTimerField);

    fieldPanel.add(jPanel1);

    jPanel11.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel11.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    multiHostField.setToolTipText("IP address used to send heartbeat broadcasts");
    multiHostField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel11.add(multiHostField);

    fieldPanel.add(jPanel11);

    jPanel12.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel12.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    portField.setToolTipText("UDP port used to listen to heartbeat broadcasts");
    portField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel12.add(portField);

    fieldPanel.add(jPanel12);

    jPanel13.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel13.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    hbIntervalField.setToolTipText("transmission rate for heartbeats");
    hbIntervalField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel13.add(hbIntervalField);

    fieldPanel.add(jPanel13);

    jPanel14.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel14.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    missedHbField.setToolTipText("number of heartbeats an application can miss before its status becomes inactive");
    missedHbField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel14.add(missedHbField);

    fieldPanel.add(jPanel14);

    jPanel15.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel15.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    proxyAuthKeyTextField.setToolTipText("word that uniquely identifies this system");
    proxyAuthKeyTextField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel15.add(proxyAuthKeyTextField);

    fieldPanel.add(jPanel15);

    jPanel16.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel16.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    redirectReasonCheckBox.setToolTipText("check to include reason for redirection in SIP headers");
    jPanel16.add(redirectReasonCheckBox);

    fieldPanel.add(jPanel16);

    centerPanelHoriz.add(fieldPanel);

    centerPanelVert.add(centerPanelHoriz);

    autoProvPanel.setLayout(new javax.swing.BoxLayout(autoProvPanel, javax.swing.BoxLayout.X_AXIS));

    autoProvPanel.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.TitledBorder("Auto-Provisioning"), new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5))));
    apLabelPanel.setLayout(new javax.swing.BoxLayout(apLabelPanel, javax.swing.BoxLayout.Y_AXIS));

    jPanel37.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel37.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    lowestUIDLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    lowestUIDLabel.setText("Lowest Userid:");
    lowestUIDLabel.setAlignmentX(1.0F);
    lowestUIDLabel.setAlignmentY(0.0F);
    jPanel37.add(lowestUIDLabel);

    apLabelPanel.add(jPanel37);

    jPanel38.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

    jPanel38.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    highestUIDLabel.setFont(new java.awt.Font("SansSerif", 1, 12));
    highestUIDLabel.setText("Highest Userid:");
    highestUIDLabel.setAlignmentX(1.0F);
    highestUIDLabel.setAlignmentY(0.0F);
    jPanel38.add(highestUIDLabel);

    apLabelPanel.add(jPanel38);

    autoProvPanel.add(apLabelPanel);

    apFieldPanel.setLayout(new javax.swing.BoxLayout(apFieldPanel, javax.swing.BoxLayout.Y_AXIS));

    jPanel17.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel17.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    lowestUIDField.setToolTipText("lowest allowable userid for auto-provisioning");
    lowestUIDField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel17.add(lowestUIDField);

    apFieldPanel.add(jPanel17);

    jPanel18.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    jPanel18.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    highestUIDField.setToolTipText("highest allowable userid for auto-provisioning");
    highestUIDField.setPreferredSize(new java.awt.Dimension(150, 20));
    jPanel18.add(highestUIDField);

    apFieldPanel.add(jPanel18);

    autoProvPanel.add(apFieldPanel);

    centerPanelVert.add(autoProvPanel);

    scrollablePanel.add(centerPanelVert, java.awt.BorderLayout.CENTER);

    jScrollPane1.setViewportView(scrollablePanel);

    mainPanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    add(mainPanel, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel apLabelPanel;
  private javax.swing.JPanel northPanel;
  private javax.swing.JLabel titleLabel;
  private javax.swing.JPanel apFieldPanel;
  private vocal.ui.WholeNumberField portField;
  private vocal.ui.HostNameField multiHostField;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel1;
  private vocal.ui.WholeNumberField expTimerField;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JPanel labelPanel;
  private javax.swing.JPanel autoProvPanel;
  private javax.swing.JLabel proxyAuthKeyLabel;
  private javax.swing.JPanel fieldPanel;
  private javax.swing.JPanel jPanel18;
  private javax.swing.JPanel jPanel17;
  private javax.swing.JPanel jPanel38;
  private javax.swing.JPanel jPanel16;
  private javax.swing.JPanel jPanel37;
  private javax.swing.JPanel jPanel15;
  private javax.swing.JPanel jPanel14;
  private javax.swing.JPanel jPanel36;
  private javax.swing.JPanel scrollablePanel;
  private vocal.ui.UserNameField lowestUIDField;
  private javax.swing.JPanel jPanel13;
  private javax.swing.JPanel jPanel35;
  private vocal.ui.WholeNumberField hbIntervalField;
  private javax.swing.JPanel jPanel12;
  private javax.swing.JLabel maxMissedHBLabel;
  private javax.swing.JPanel jPanel34;
  private javax.swing.JLabel multicastPortLabel;
  private javax.swing.JPanel jPanel11;
  private javax.swing.JPanel jPanel33;
  private javax.swing.JPanel jPanel32;
  private javax.swing.JPanel jPanel31;
  private javax.swing.JLabel lowestUIDLabel;
  private javax.swing.JLabel redirectReasonLabel;
  private javax.swing.JLabel multicastHostLabel;
  private vocal.ui.UserNameField highestUIDField;
  private javax.swing.JPanel centerPanelHoriz;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JLabel highestUIDLabel;
  private vocal.ui.WholeNumberField missedHbField;
  private vocal.ui.InternalClipboardField proxyAuthKeyTextField;
  private javax.swing.JCheckBox redirectReasonCheckBox;
  private javax.swing.JLabel expiryTimerLabel;
  private javax.swing.JLabel heartBeatIntLabel;
  private javax.swing.JPanel centerPanelVert;
  // End of variables declaration//GEN-END:variables
  
  
  /**
   *
   */
  public String getExpTimerField()
  {
    return expTimerField.getText();
  }
  
  /**
   *
   */
  public String getMultiHostField()
  {
    return multiHostField.getText();
  }
  
  /**
   *
   */
  public String getPortField()
  {
    return portField.getText();
  }
  
  /**
   *
   */
  public String gethbIntervalField()
  {
    return hbIntervalField.getText();
  }
  
  /**
   *
   */
  public String getMissedHbField()
  {
    return missedHbField.getText();
  }
  
  /**
   *
   * @param str
   */
  public void setExpTimerField(String str)
  {
    expTimerField.setText(str);
  }
  
  /**
   *
   * @param str
   */
  public void setMultiHostField(String str)
  {
    multiHostField.setText(str);
  }
  
  /**
   *
   * @param str
   */
  public void setPortField(String str)
  {
    portField.setText(str);
  }
  
  /**
   *
   * @param str
   */
  public void sethbIntervalField(String str)
  {
    hbIntervalField.setText(str);
  }
  
  /**
   *
   * @param str
   */
  public void setMissedHbField(String str)
  {
    missedHbField.setText(str);
  }
  
  /**
   */
  public void displayData()
  {
    if (dataManager != null)
    {
      try
      {
        setExpTimerField(dataManager.getExpiryTimerData());
        setMultiHostField(dataManager.getMulticastHostData());
        setPortField(dataManager.getMulticastPortData());
        sethbIntervalField(dataManager.getHeartbeatIntervalData());
        setMissedHbField(dataManager.getMissedHeartbeatsData());
        proxyAuthKeyTextField.setText(dataManager.getProxyAuthKeyData());
        redirectReasonCheckBox.setSelected(dataManager.getRedirectReasonData());
        lowestUIDField.setText(dataManager.getLowestUIDData());
        highestUIDField.setText(dataManager.getHighestUIDData());
        
        toValidate.clear();
        toValidate.add(expTimerField);
        toValidate.add(multiHostField);
        toValidate.add(portField);
        toValidate.add(hbIntervalField);
        toValidate.add(missedHbField);
        toValidate.add(lowestUIDField);
        toValidate.add(highestUIDField);
        
      }
      catch (InvalidRequestException e)
      {
        e.printStackTrace();
      }
    }
  }
  
  /**
   */
  protected void getData()
  {
    if (dataManager != null)
    {
      try
      {
        dataManager.setExpiryTimerData(getExpTimerField());
        dataManager.setMulticastHostData(getMultiHostField());
        dataManager.setMulticastPortData(getPortField());
        dataManager.setHeartbeatIntervalData(gethbIntervalField());
        dataManager.setMissedHeartbeatsData(getMissedHbField());
        dataManager.setProxyAuthKeyData(proxyAuthKeyTextField.getText());
        dataManager.setRedirectReasonData(redirectReasonCheckBox.isSelected());
        dataManager.setLowestUIDData(lowestUIDField.getText());
        dataManager.setHighestUIDData(highestUIDField.getText());
      }
      catch (InvalidRequestException e)
      {
        e.printStackTrace();
      }
    }
  }
  
  /**
   */
  public void activate()
  {
    dataManager = configTree1.getGlobalData();
    
    displayData();
  }
  
  // Action Listener
  
  /**
   *
   * @param ev
   */
  public void actionPerformed(ActionEvent ev)
  {
    if (ev.getSource() == mainScreen.getOkButton())
    {
      System.out.println("\n Systemdata -> Ok Button Pressed");
      
      if (!checkValidated())
      {
        return;
      }
      
      dataManager = configTree1.getGlobalData();
      
      getData();
      
      if (dataManager != null)
      {
        try
        {
          dataManager.saveData();
        }
        catch (InvalidRequestException e)
        {}
      }
      
      dataManager = configTree1.getGlobalData();
      
      mainScreen.enableTree();
    }
  }
  
}


