#! /bin/sh

# this script generates keys and certificates for using secured
# provisioning:

VOCAL_ETC=/usr/local/vocal/etc
HOSTNAME=`hostname`

# generate the key
openssl genrsa 512/1024 > ${VOCAL_ETC}/key.pem

# now, create the mkreq.txt which has the right bits

cat > /tmp/mkreq.$$ <<EOF
[ req ] 
prompt=no
distinguished_name = req_distinguished_name
attributes=xyz
crl_days=365
[ req_distinguished_name ]
CN=${HOSTNAME}
[ xyz ]
EOF

# now, generate the certificate request
openssl req -config /tmp/mkreq.$$ -new -key ${VOCAL_ETC}/key.pem \
    > ${VOCAL_ETC}/csr.pem

# self-sign the certificate request
openssl req -days 365 -x509 -key ${VOCAL_ETC}/key.pem \
    -in ${VOCAL_ETC}/csr.pem \
    > ${VOCAL_ETC}/cert.pem

rm /tmp/mkreq.$$
