
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

/*
 * $Id$
 */

#ifndef SUARSVP_H
#define SUARSVP_H

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h> /* for sockaddr_in, in_addr in rapi_lib.h */
#include "rapi_lib.h"

#include <stdio.h>
#include "NetworkAddress.h"

int upcallHandler(rapi_sid_t, rapi_eventinfo_t, int,
                  int, int, struct sockaddr *, u_char,
                  int, rapi_filter_t *, int, rapi_flowspec_t *,
                  int, rapi_adspec_t *, void *);


class SuaRsvp
{
    public:
        SuaRsvp ();

        SuaRsvp ( const SuaRsvp& src );

        SuaRsvp& operator =(const SuaRsvp& src);

        int session(NetworkAddress* destAddr);

        int sender(NetworkAddress* srcAddr);

        int reserve(NetworkAddress* rcvAddr);

        int close();

    public:

        int session_id;

        // proto
        int proto_id;

        struct sockaddr dest_addr;
        struct sockaddr src_addr;
        struct sockaddr rcv_addr;

        // reservation style
        rapi_styleid_t style;

        rapi_filter_t snd_template;
        rapi_tspec_t snd_tspec;
        rapi_adspec_t snd_adspec;

        rapi_flowspec_t flowspec_cl;
        rapi_flowspec_t flowspec_g;
        rapi_filter_t filter_spec;

        int ttl;

        int resv_flag;
        int rapi_fd;


};

#endif
